commit:     18cc6458425a80fa8cc090f4066add9c3319c8a2
Author:     Esteve Varela Colominas <esteve.varela <AT> gmail <DOT> com>
AuthorDate: Sat Aug 13 14:06:42 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Tue Aug 23 05:23:59 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=18cc6458
net-im/telegram-desktop: Bump to 4.1.0

Signed-off-by: Esteve Varela Colominas <esteve.varela <AT> gmail.com>
Signed-off-by: Sam James <sam <AT> gentoo.org>

 net-im/telegram-desktop/Manifest                   |   1 +
 .../files/tdesktop-3.3.0-fix-enchant.patch         |   2 +
 .../tdesktop-3.6.0-jemalloc-only-telegram.patch    |   2 +
 ...tdesktop-4.1.0-fix-unique_ptr-declaration.patch |  25 +++
 .../telegram-desktop/telegram-desktop-4.1.0.ebuild | 182 +++++++++++++++++++++
 5 files changed, 212 insertions(+)

diff --git a/net-im/telegram-desktop/Manifest b/net-im/telegram-desktop/Manifest
index 5cc1ba90b246..fc3d53da412e 100644
--- a/net-im/telegram-desktop/Manifest
+++ b/net-im/telegram-desktop/Manifest
@@ -1,2 +1,3 @@
 DIST tdesktop-3.6.1-full.tar.gz 41226549 BLAKE2B 
6922ae015e36f86597aaedf1212ed951d6313a8f5f76a8838ab7ef9e02afe0cbc428acd991488190bafdf28faf2a69a09a5a1e963b2aa6ed27ef941602e15d88
 SHA512 
dd216c720ea3b1c72669805bb31319746a7ddfe746d188bf2ae0c5cdf0a10b379fc2e888a26fe755d77381fc5d9aa638cedc76b2dce1f1126a9c1ef9c02da2ba
 DIST tdesktop-4.0.2-full.tar.gz 41059443 BLAKE2B 
da4efb15c8a2d11719d3aa56c3a40b12f70c37577d2909c43e6029e10ca0bb1f8445ed68ed9acd532009c8e0a8f48fa13d2a51573a81f58a8a83b13427ffb631
 SHA512 
0078b627d06dd8e655bd2bcc222ecbb3b15b7d88f858810bccdca84793ad02a60f4a4bf3808838752d65d4f6cffa3ddb5f70c5afc8e94cb6edae52101362feeb
+DIST tdesktop-4.1.0-full.tar.gz 41431524 BLAKE2B 
041e3561a1666e60ccee8ca002a413cc773cd5aa7e42f8c1ca5878860eb9ed2d8175c78929b32c25530b511877751982c191dd3be182daf31808c439eedb2705
 SHA512 
d58ad4b3eaf72b4885612ecca0b29057a1f0e7efc7a539c4ed7cdfa9f6b8dd19e378f1e4b9f28a644d8c8559a5310a168e0b949aafac6902bd21155795db2574

diff --git a/net-im/telegram-desktop/files/tdesktop-3.3.0-fix-enchant.patch 
b/net-im/telegram-desktop/files/tdesktop-3.3.0-fix-enchant.patch
index 35781fda0ced..7550828ef59e 100644
--- a/net-im/telegram-desktop/files/tdesktop-3.3.0-fix-enchant.patch
+++ b/net-im/telegram-desktop/files/tdesktop-3.3.0-fix-enchant.patch
@@ -1,3 +1,5 @@
+https://bugs.gentoo.org/830180
+
 --- 
tdesktop-3.3.0-full.orig/Telegram/lib_spellcheck/spellcheck/platform/linux/spellcheck_linux.cpp
 +++ 
tdesktop-3.3.0-full/Telegram/lib_spellcheck/spellcheck/platform/linux/spellcheck_linux.cpp
 @@ -34,7 +34,7 @@

diff --git 
a/net-im/telegram-desktop/files/tdesktop-3.6.0-jemalloc-only-telegram.patch 
b/net-im/telegram-desktop/files/tdesktop-3.6.0-jemalloc-only-telegram.patch
index 6836e6935049..18240ce522e2 100644
--- a/net-im/telegram-desktop/files/tdesktop-3.6.0-jemalloc-only-telegram.patch
+++ b/net-im/telegram-desktop/files/tdesktop-3.6.0-jemalloc-only-telegram.patch
@@ -5,6 +5,8 @@ jemalloc is linked for those, and they're ran under portage's 
sandbox. Since
 this is only used during build-time, and jemalloc is merely necessary to
 improve runtime memory use, it's unnecessary to use it for anything else.
 
+https://bugs.gentoo.org/802624
+
 --- tdesktop-3.6.0-full.orig/Telegram/CMakeLists.txt
 +++ tdesktop-3.6.0-full/Telegram/CMakeLists.txt
 @@ -1376,6 +1376,14 @@

diff --git 
a/net-im/telegram-desktop/files/tdesktop-4.1.0-fix-unique_ptr-declaration.patch 
b/net-im/telegram-desktop/files/tdesktop-4.1.0-fix-unique_ptr-declaration.patch
new file mode 100644
index 000000000000..46d7afe1851e
--- /dev/null
+++ 
b/net-im/telegram-desktop/files/tdesktop-4.1.0-fix-unique_ptr-declaration.patch
@@ -0,0 +1,25 @@
+Fix declaration of std::unique_ptr
+
+I'm not sure if this is an inherent tdesktop issue or if it's related to any
+new version of a tool...
+
+--- tdesktop-4.1.0-full.orig/Telegram/SourceFiles/ffmpeg/ffmpeg_emoji.h
++++ tdesktop-4.1.0-full/Telegram/SourceFiles/ffmpeg/ffmpeg_emoji.h
+@@ -9,6 +9,7 @@
+ 
+ #include "ui/effects/frame_generator.h"
+ 
++#include <memory>
+ #include <QtGui/QImage>
+ 
+ namespace FFmpeg {
+--- tdesktop-4.1.0-full.orig/Telegram/lib_lottie/lottie/lottie_emoji.h
++++ tdesktop-4.1.0-full/Telegram/lib_lottie/lottie/lottie_emoji.h
+@@ -8,6 +8,7 @@
+ 
+ #include "ui/effects/frame_generator.h"
+ 
++#include <memory>
+ #include <QtGui/QImage>
+ 
+ namespace rlottie {

diff --git a/net-im/telegram-desktop/telegram-desktop-4.1.0.ebuild 
b/net-im/telegram-desktop/telegram-desktop-4.1.0.ebuild
new file mode 100644
index 000000000000..014988de2f0e
--- /dev/null
+++ b/net-im/telegram-desktop/telegram-desktop-4.1.0.ebuild
@@ -0,0 +1,182 @@
+# Copyright 2020-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..11} )
+
+inherit xdg cmake python-any-r1 optfeature
+
+DESCRIPTION="Official desktop client for Telegram"
+HOMEPAGE="https://desktop.telegram.org";
+
+MY_P="tdesktop-${PV}-full"
+SRC_URI="https://github.com/telegramdesktop/tdesktop/releases/download/v${PV}/${MY_P}.tar.gz";
+S="${WORKDIR}/${MY_P}"
+
+LICENSE="BSD GPL-3-with-openssl-exception LGPL-2+"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~riscv"
+IUSE="+dbus enchant +hunspell +jemalloc screencast +spell qt6 wayland +X"
+REQUIRED_USE="
+       spell? (
+               ^^ ( enchant hunspell )
+       )
+"
+
+RDEPEND="
+       !net-im/telegram-desktop-bin
+       app-arch/lz4:=
+       dev-cpp/abseil-cpp:=
+       dev-libs/libdispatch
+       dev-libs/openssl:=
+       dev-libs/xxhash
+       media-fonts/open-sans
+       media-libs/fontconfig:=
+       ~media-libs/libtgvoip-2.4.4_p20220503
+       media-libs/openal
+       media-libs/opus:=
+       media-libs/rnnoise
+       ~media-libs/tg_owt-0_pre20220507[screencast=,X=]
+       media-video/ffmpeg:=[opus]
+       sys-libs/zlib:=[minizip]
+       dbus? ( dev-cpp/glibmm:2 )
+       enchant? ( app-text/enchant:= )
+       hunspell? ( >=app-text/hunspell-1.7:= )
+       jemalloc? ( dev-libs/jemalloc:=[-lazy-lock] )
+       !qt6? (
+               >=dev-qt/qtcore-5.15:5
+               >=dev-qt/qtgui-5.15:5[dbus?,jpeg,png,wayland?,X?]
+               >=dev-qt/qtimageformats-5.15:5
+               >=dev-qt/qtnetwork-5.15:5[ssl]
+               >=dev-qt/qtsvg-5.15:5
+               >=dev-qt/qtwidgets-5.15:5[png,X?]
+       )
+       qt6? (
+               dev-qt/qtbase:6[dbus?,gui,network,opengl,widgets,X?]
+               dev-qt/qtsvg:6
+               dev-qt/qt5compat:6
+               wayland? ( dev-qt/qtwayland:6 )
+       )
+       X? ( x11-libs/libxcb:= )
+"
+DEPEND="${RDEPEND}
+       dev-cpp/range-v3
+       =dev-cpp/ms-gsl-3*
+"
+BDEPEND="
+       ${PYTHON_DEPS}
+       >=dev-util/cmake-3.16
+       virtual/pkgconfig
+"
+# dev-libs/jemalloc:=[-lazy-lock] -> https://bugs.gentoo.org/803233
+
+PATCHES=(
+       "${FILESDIR}/tdesktop-3.6.0-jemalloc-only-telegram.patch"
+       "${FILESDIR}/tdesktop-3.3.0-fix-enchant.patch"
+       "${FILESDIR}/tdesktop-3.5.2-musl.patch"
+       "${FILESDIR}/tdesktop-4.0.2-fix-gcc12-cstdint.patch"
+       "${FILESDIR}/tdesktop-4.1.0-fix-unique_ptr-declaration.patch"
+)
+
+# Current desktop-file-utils-0.26 does not understand Version=1.5
+QA_DESKTOP_FILE="usr/share/applications/${PN}.desktop"
+
+pkg_pretend() {
+       if has ccache ${FEATURES}; then
+               ewarn "ccache does not work with ${PN} out of the box"
+               ewarn "due to usage of precompiled headers"
+               ewarn "check bug https://bugs.gentoo.org/715114 for more info"
+               ewarn
+       fi
+       if use qt6; then
+               ewarn "Qt6 support in gentoo is experimental."
+               ewarn "Please report any issues you may find, but don't expect"
+               ewarn "everything to work correctly as of yet."
+               ewarn
+       fi
+}
+
+src_prepare() {
+       # no explicit toggle, doesn't build with the system one #752417
+       sed -i 's/DESKTOP_APP_USE_PACKAGED/NO_ONE_WILL_EVER_SET_THIS/' \
+               cmake/external/rlottie/CMakeLists.txt || die
+
+       cmake_src_prepare
+}
+
+src_configure() {
+       # DESKTOP_APP_DISABLE_JEMALLOC is heavily discouraged by upstream, as 
the
+       # glibc allocator results in high memory usage.
+       # https://github.com/telegramdesktop/tdesktop/issues/16084
+       # 
https://github.com/desktop-app/cmake_helpers/pull/91#issuecomment-881788003
+
+       # DESKTOP_APP_QT6=OFF force-enables 
DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION
+       # This means that REQUIRED_USE="wayland? ( qt6 )", but a lot of people
+       # enable USE=wayland globally, so we instead silently disable it...
+
+       local mycmakeargs=(
+               -DTDESKTOP_LAUNCHER_BASENAME="${PN}"
+               -DCMAKE_DISABLE_FIND_PACKAGE_tl-expected=ON  # header only lib, 
some git version. prevents warnings.
+               -DDESKTOP_APP_QT6=$(usex qt6)
+
+               -DDESKTOP_APP_DISABLE_DBUS_INTEGRATION=$(usex !dbus)
+               -DDESKTOP_APP_DISABLE_X11_INTEGRATION=$(usex !X)
+               -DDESKTOP_APP_DISABLE_WAYLAND_INTEGRATION=$(usex !wayland)
+               -DDESKTOP_APP_DISABLE_JEMALLOC=$(usex !jemalloc)
+               -DDESKTOP_APP_DISABLE_SPELLCHECK=$(usex !spell)  # enables 
hunspell (recommended)
+               -DDESKTOP_APP_USE_ENCHANT=$(usex enchant)  # enables enchant 
and disables hunspell
+       )
+
+       if [[ -n ${MY_TDESKTOP_API_ID} && -n ${MY_TDESKTOP_API_HASH} ]]; then
+               einfo "Found custom API credentials"
+               mycmakeargs+=(
+                       -DTDESKTOP_API_ID="${MY_TDESKTOP_API_ID}"
+                       -DTDESKTOP_API_HASH="${MY_TDESKTOP_API_HASH}"
+               )
+       else
+               # 
https://github.com/telegramdesktop/tdesktop/blob/dev/snap/snapcraft.yaml
+               # Building with snapcraft API credentials by default
+               # Custom API credentials can be obtained here:
+               # 
https://github.com/telegramdesktop/tdesktop/blob/dev/docs/api_credentials.md
+               # After getting credentials you can export variables:
+               #  export MY_TDESKTOP_API_ID="17349""
+               #  export 
MY_TDESKTOP_API_HASH="344583e45741c457fe1862106095a5eb"
+               # and restart the build"
+               # you can set above variables (without export) in 
/etc/portage/env/net-im/telegram-desktop
+               # portage will use custom variable every build automatically
+               mycmakeargs+=(
+                       -DTDESKTOP_API_ID="611335"
+                       -DTDESKTOP_API_HASH="d524b414d21f4d37f08684c1df41ac9c"
+               )
+       fi
+
+       cmake_src_configure
+}
+
+pkg_postinst() {
+       xdg_pkg_postinst
+       if ! use X && ! use screencast; then
+               elog "both the 'X' and 'screencast' useflags are disabled, 
screen sharing won't work!"
+               elog
+       fi
+       if has_version '<dev-qt/qtcore-5.15.2-r10'; then
+               ewarn "Versions of dev-qt/qtcore lower than 5.15.2-r10 might 
cause telegram"
+               ewarn "to crash when pasting big images from the clipboard."
+               ewarn
+       fi
+       if ! use jemalloc && use elibc_glibc; then
+               ewarn "Disabling USE=jemalloc on glibc systems may cause very 
high RAM usage!"
+               ewarn "Do NOT report issues about RAM usage without enabling 
this flag first."
+               ewarn
+       fi
+       if use wayland && ! use qt6; then
+               ewarn "Wayland-specific integrations have been deprecated with 
Qt5."
+               ewarn "The app will continue to function under wayland, but 
some"
+               ewarn "functionality may be reduced."
+               ewarn "These integrations are only supported when built with 
Qt6."
+               ewarn
+       fi
+       optfeature_header
+       optfeature "shop payment support (requires USE=dbus enabled)" 
net-libs/webkit-gtk
+}

Reply via email to